package bcn;


public class LocalInputRef<T> implements InputRef<T> {
    
    public final InputPort<T> port;
    
    
    public LocalInputRef(InputPort<T> port) {
        this.port = port;
    }
    
    
    @Override
    public void send(T msg) {
        port.put(msg);
    }
    
}
